'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InlineBlock = exports.Column = exports.Row = exports.Flex = exports.Block = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('./index');

var glamor = _interopRequireWildcard(_index);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

// import shallowCompare from 'react-addons-shallow-compare'
var withKeys = function withKeys() {
  for (var _len = arguments.length, keys = Array(_len), _key = 0; _key < _len; _key++) {
    keys[_key] = arguments[_key];
  }

  return keys.reduce(function (o, k) {
    return o[k] = true, o;
  }, {});
};

var pseudos = withKeys(
// pseudoclasses
'active', 'any', 'checked', 'disabled', 'empty', 'enabled', '_default', 'first', 'firstChild', 'firstOfType', 'fullscreen', 'focus', 'hover', 'indeterminate', 'inRange', 'invalid', 'lastChild', 'lastOfType', 'left', 'link', 'onlyChild', 'onlyOfType', 'optional', 'outOfRange', 'readOnly', 'readWrite', 'required', 'right', 'root', 'scope', 'target', 'valid', 'visited',
// pseudoelements
'after', 'before', 'firstLetter', 'firstLine', 'selection', 'backdrop', 'placeholder');
var parameterizedPseudos = withKeys('dir', 'lang', 'not', 'nthChild', 'nthLastChild', 'nthLastOfType', 'nthOfType');

var STYLE_PROP_NAMES = Object.keys(document.createElement('div').style).reduce(function (styles, key) {
  styles[key] = true;
  return styles;
}, {});

var splitStyles = function splitStyles(combinedProps) {
  var props = {},
      gStyle = {},
      style = {};
  Object.keys(combinedProps).forEach(function (key) {
    if (STYLE_PROP_NAMES[key]) style[key] = combinedProps[key];else if (pseudos[key] >= 0) {
      Object.assign(gStyle, glamor[key](combinedProps[key]));
    } else if (parameterizedPseudos[key]) {
      Object.assign(gStyle, glamor[key].apply(glamor, _toConsumableArray(combinedProps[key])));
    } else props[key] = combinedProps[key];
  });
  return _extends({}, glamor.style(style), gStyle, props);
};

var Block = exports.Block = function (_React$Component) {
  _inherits(Block, _React$Component);

  function Block() {
    _classCallCheck(this, Block);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Block).apply(this, arguments));
  }

  _createClass(Block, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var Component = _props.component;

      var props = _objectWithoutProperties(_props, ['component']);

      return _react2.default.createElement(Component, splitStyles(props));
    }
  }]);

  return Block;
}(_react2.default.Component);

Block.defaultProps = {
  component: 'div'
};

var Flex = exports.Flex = function (_React$Component2) {
  _inherits(Flex, _React$Component2);

  function Flex() {
    _classCallCheck(this, Flex);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Flex).apply(this, arguments));
  }

  _createClass(Flex, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(Block, _extends({}, this.props, { display: 'flex' }));
    }
  }]);

  return Flex;
}(_react2.default.Component);

var Row = exports.Row = function (_React$Component3) {
  _inherits(Row, _React$Component3);

  function Row() {
    _classCallCheck(this, Row);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Row).apply(this, arguments));
  }

  _createClass(Row, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(Flex, _extends({}, this.props, { flexDirection: 'row' }));
    }
  }]);

  return Row;
}(_react2.default.Component);

var Column = exports.Column = function (_React$Component4) {
  _inherits(Column, _React$Component4);

  function Column() {
    _classCallCheck(this, Column);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Column).apply(this, arguments));
  }

  _createClass(Column, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(Flex, _extends({}, this.props, { flexDirection: 'column' }));
    }
  }]);

  return Column;
}(_react2.default.Component);

var InlineBlock = exports.InlineBlock = function (_React$Component5) {
  _inherits(InlineBlock, _React$Component5);

  function InlineBlock() {
    _classCallCheck(this, InlineBlock);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(InlineBlock).apply(this, arguments));
  }

  _createClass(InlineBlock, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(Block, _extends({}, this.props, { display: 'inline-block' }));
    }
  }]);

  return InlineBlock;
}(_react2.default.Component);